package com.company.util;

import java.io.File;
import java.io.FilenameFilter;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ServletJBPMContext implements ServletContextListener {

    private static Logger log = LoggerFactory.getLogger("ServletJBPMContext.class");

    public void contextInitialized(ServletContextEvent arg0) {

        /*
         * Create the runtime manager
         */
        log.info("initilaze runtime at server startup");
        PerRequestRuntimeManager.getInstance().getRuntimeManager();
        log.info("completed ..");
    }

    public void contextDestroyed(ServletContextEvent arg0) {

        log.debug("Context destroyed ");
        File tempDir = new File(System.getProperty("java.io.tmpdir"));
        if (tempDir.exists()) {
            String[] jbpmSerFiles = tempDir.list(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.endsWith("-jbpmSessionId.ser");
                }
            });
            for (String file : jbpmSerFiles) {

                new File(tempDir, file).delete();
            }
        }
    }

}
